#include <stdio.h>
#include <vpi_user.h>


static int s_itr_compiletf(char*user_data)
{
      return 0;
}



static int s_itr_calltf(char*user_data)
{
  int left_addr, right_addr, ix_addr;
  vpiHandle systfref, args_iter, argh;
  //struct t_vpi_value argval;
  s_vpi_value argval;

  systfref  = vpi_handle(vpiSysTfCall, NULL);
  args_iter = vpi_iterate(vpiArgument, systfref);

   argh = vpi_scan(args_iter);
   argval.format = vpiIntVal;
   vpi_get_value(vpi_handle(vpiLeftRange, argh), &argval);
   left_addr = argval.value.integer;
   argval.format = vpiIntVal;
   vpi_get_value(vpi_handle(vpiRightRange, argh), &argval);
   right_addr = argval.value.integer;

  vpi_printf("the address range is %x %x\n", left_addr, right_addr);
  vpiHandle h3;
  s_vpi_value ar_da;

  for(ix_addr=left_addr; ix_addr <= right_addr; ix_addr++) {
    h3 = vpi_handle_by_index(argh, ix_addr);
    ar_da.format = vpiIntVal;
    vpi_get_value (h3, &ar_da);
    vpi_printf("the value is %d\n", ar_da.value.integer);
  }

  return 0;
}

void s_itr_register()
{
      s_vpi_systf_data tf_data;

      tf_data.type      = vpiSysTask;
      tf_data.tfname    = "$s_itr";
      tf_data.calltf    = s_itr_calltf;
      tf_data.compiletf = s_itr_compiletf;
      tf_data.sizetf    = 0;
      tf_data.user_data = 0;
      vpi_register_systf(&tf_data);
}

void (*vlog_startup_routines[])() = {
    s_itr_register,
    0
};

